--- old/usr/src/lib/libdladm/common/libdlwlan.c	2012-06-12 19:54:54.906974412 +0200
+++ new/usr/src/lib/libdladm/common/libdlwlan.c	2012-06-12 19:54:54.929856467 +0200
@@ -37,22 +37,17 @@
 #include <net/if_types.h>
 #include <libdlpi.h>
 #include <libdllink.h>
-#include <libscf.h>
 #include <libdlwlan.h>
 #include <libdladm_impl.h>
 #include <libdlwlan_impl.h>
-#include <net/wpa.h>
 
-static dladm_status_t	wpa_instance_create(dladm_handle_t, datalink_id_t,
-			    void *);
-static dladm_status_t	wpa_instance_delete(dladm_handle_t, datalink_id_t);
+static int wpa_instance_create(char *ifname);
+static int wpa_instance_delete(char *ifname);
+static int wpa_network_config(char *ifname, dladm_wlan_attr_t *attrp,
+	dladm_wlan_key_t *keys, boolean_t *create_ibss, char *identity);
 
 static dladm_status_t 	do_get_bsstype(dladm_handle_t, datalink_id_t, void *,
 			    int);
-static dladm_status_t 	do_get_essid(dladm_handle_t, datalink_id_t, void *,
-			    int);
-static dladm_status_t 	do_get_bssid(dladm_handle_t, datalink_id_t, void *,
-			    int);
 static dladm_status_t 	do_get_signal(dladm_handle_t, datalink_id_t, void *,
 			    int);
 static dladm_status_t 	do_get_encryption(dladm_handle_t, datalink_id_t, void *,
@@ -61,34 +56,13 @@
 			    int);
 static dladm_status_t 	do_get_linkstatus(dladm_handle_t, datalink_id_t, void *,
 			    int);
-static dladm_status_t	do_get_esslist(dladm_handle_t, datalink_id_t, void  *,
-			    int);
 static dladm_status_t 	do_get_rate(dladm_handle_t, datalink_id_t, void *, int);
 static dladm_status_t	do_get_mode(dladm_handle_t, datalink_id_t, void *, int);
-static dladm_status_t	do_get_capability(dladm_handle_t, datalink_id_t, void *,
-			    int);
 static dladm_status_t	do_get_wpamode(dladm_handle_t, datalink_id_t, void *,
 			    int);
-
-static dladm_status_t	do_set_bsstype(dladm_handle_t, datalink_id_t,
-			    dladm_wlan_bsstype_t *);
-static dladm_status_t	do_set_authmode(dladm_handle_t, datalink_id_t,
-			    dladm_wlan_auth_t *);
-static dladm_status_t	do_set_encryption(dladm_handle_t, datalink_id_t,
-			    dladm_wlan_secmode_t *);
-static dladm_status_t	do_set_essid(dladm_handle_t, datalink_id_t,
-			    dladm_wlan_essid_t *);
-static dladm_status_t	do_set_createibss(dladm_handle_t, datalink_id_t,
-			    boolean_t *);
 static dladm_status_t	do_set_key(dladm_handle_t, datalink_id_t,
 			    dladm_wlan_key_t *, uint_t);
-static dladm_status_t	do_set_channel(dladm_handle_t, datalink_id_t,
-			    dladm_wlan_channel_t *);
-
 static dladm_status_t	do_scan(dladm_handle_t, datalink_id_t, void *, int);
-static dladm_status_t	do_connect(dladm_handle_t, datalink_id_t, void *, int,
-			    dladm_wlan_attr_t *, boolean_t, void *, uint_t,
-			    int);
 static dladm_status_t	do_disconnect(dladm_handle_t, datalink_id_t, void *,
 			    int);
 static boolean_t	find_val_by_name(const char *, val_desc_t *,
@@ -105,9 +79,10 @@
 };
 
 static val_desc_t 	secmode_vals[] = {
-	{ "none",	DLADM_WLAN_SECMODE_NONE		},
-	{ "wep",	DLADM_WLAN_SECMODE_WEP		},
-	{ "wpa",	DLADM_WLAN_SECMODE_WPA		}
+	{ "none",	DLADM_WLAN_SECMODE_NONE	},
+	{ "wep",	DLADM_WLAN_SECMODE_WEP	},
+	{ "wpa-psk",	DLADM_WLAN_SECMODE_PSK	},
+	{ "wpa-eap",	DLADM_WLAN_SECMODE_EAP	}
 };
 
 static val_desc_t 	strength_vals[] = {
@@ -126,19 +101,17 @@
 	{ "n",		DLADM_WLAN_MODE_80211AN		}
 };
 
+/* capital chars*/
 static val_desc_t	auth_vals[] = {
-	{ "open",	DLADM_WLAN_AUTH_OPEN		},
-	{ "shared",	DLADM_WLAN_AUTH_SHARED		}
+	{ "OPEN",	DLADM_WLAN_AUTH_OPEN		},
+	{ "SHARED",	DLADM_WLAN_AUTH_SHARED		}
 };
 
 static val_desc_t	bsstype_vals[] = {
 	{ "bss",	DLADM_WLAN_BSSTYPE_BSS		},
-	{ "ibss",	DLADM_WLAN_BSSTYPE_IBSS		},
-	{ "any",	DLADM_WLAN_BSSTYPE_ANY		}
+	{ "ibss",	DLADM_WLAN_BSSTYPE_IBSS		}
 };
 
-#define	WLDP_BUFSIZE (MAX_BUF_LEN - WIFI_BUF_OFFSET)
-
 static dladm_status_t
 dladm_wlan_wlresult2status(wldp_t *gbuf)
 {
@@ -206,36 +179,75 @@
 	return (B_TRUE);
 }
 
-#define	IEEE80211_RATE	0x7f
 static void
 fill_wlan_attr(wl_ess_conf_t *wlp, dladm_wlan_attr_t *attrp)
 {
-	int		i;
+	int i;
 
 	(void) memset(attrp, 0, sizeof (*attrp));
 
-	(void) snprintf(attrp->wa_essid.we_bytes, DLADM_WLAN_MAX_ESSID_LEN,
-	    "%s", wlp->wl_ess_conf_essid.wl_essid_essid);
+	attrp->wa_essid.we_length = wlp->wl_ess_conf_essid.wl_essid_length;
+	(void) memcpy(attrp->wa_essid.we_bytes, wlp->wl_ess_conf_essid.wl_essid_essid,
+	    attrp->wa_essid.we_length);
 	attrp->wa_valid |= DLADM_WLAN_ATTR_ESSID;
 
+	/*
+	 * Note: SSID is an array of octets, i.e.,
+	 * it is not nul terminated and can, at least in theory,
+	 * contain control characters (including nul) and as such,
+	 * should be processed as binary data, not a printable string.
+	 *
+	 *the following call has been replaced with the one above:
+	 *(void) snprintf(attrp->wa_essid.we_bytes, DLADM_WLAN_MAX_ESSID_LEN,
+	 *   "%s", wlp->wl_ess_conf_essid.wl_essid_essid);
+	*/
+
 	(void) memcpy(attrp->wa_bssid.wb_bytes, wlp->wl_ess_conf_bssid,
 	    DLADM_WLAN_BSSID_LEN);
 	attrp->wa_valid |= DLADM_WLAN_ATTR_BSSID;
 
-	attrp->wa_secmode = (wlp->wl_ess_conf_wepenabled ==
-	    WL_ENC_WEP ? DLADM_WLAN_SECMODE_WEP : DLADM_WLAN_SECMODE_NONE);
-	if (wlp->wl_ess_conf_reserved[0] > 0)
-		attrp->wa_secmode = DLADM_WLAN_SECMODE_WPA;
+	/*
+	 * Open/Shared is simply not present in the AP's beacon.  It is a
+	 * deficiency of WEP, which WPA fixed by only allowing open
+	 * authentication for WPA connections. There is simply no way to tell
+	 * whether an AP is using shared auth or open system auth because a WEP
+	 * AP never broadcasts that information.
+	 * [net80211 sets it to 1 (OPEN) by default for scanned nodes]
+	 *
+	 * If wpa_ie is not present and IEEE80211_CAP_PRIVACY is on => WEP
+	 * If wpa_ie is not present and IEEE80211_CAP_PRIVACY is off => NONE
+	 */
+
+	if (wlp->wl_ess_conf_wpa_ie_len == 0) {
+		if (wlp->wl_ess_conf_caps & IEEE80211_CAP_PRIVACY) {
+			attrp->wa_auth = DLADM_WLAN_AUTH_SHARED;
+			attrp->wa_secmode = DLADM_WLAN_SECMODE_WEP;
+		} else {
+			attrp->wa_auth = DLADM_WLAN_AUTH_NONE;
+			attrp->wa_secmode = DLADM_WLAN_SECMODE_NONE;
+		}
+	} else {
+		attrp->wa_auth = DLADM_WLAN_AUTH_OPEN;
+		wpa_parse_wpa_ie(wlp->wl_ess_conf_wpa_ie,
+		    wlp->wl_ess_conf_wpa_ie_len, &attrp->wa_ie);
+		/*
+		 * check wpa_ie.c defines
+		 */
+		if (attrp->wa_ie.key_mgmt == 0)
+			attrp->wa_secmode = DLADM_WLAN_SECMODE_EAP;
+		if (attrp->wa_ie.key_mgmt == 2)
+			attrp->wa_secmode = DLADM_WLAN_SECMODE_PSK;
+	}
+	attrp->wa_valid |= DLADM_WLAN_ATTR_AUTH;
 	attrp->wa_valid |= DLADM_WLAN_ATTR_SECMODE;
 
-	attrp->wa_bsstype = (wlp->wl_ess_conf_bsstype == WL_BSS_BSS ?
-	    DLADM_WLAN_BSSTYPE_BSS : DLADM_WLAN_BSSTYPE_IBSS);
+	/* caps values are not mutually-exclusive here */
+	if (wlp->wl_ess_conf_caps & IEEE80211_CAP_IBSS)
+	    	attrp->wa_bsstype = DLADM_WLAN_BSSTYPE_IBSS;
+	if (wlp->wl_ess_conf_caps & IEEE80211_CAP_ESS)
+	    	attrp->wa_bsstype = DLADM_WLAN_BSSTYPE_BSS;
 	attrp->wa_valid |= DLADM_WLAN_ATTR_BSSTYPE;
 
-	attrp->wa_auth = (wlp->wl_ess_conf_authmode == 0 ?
-	    DLADM_WLAN_AUTH_OPEN : DLADM_WLAN_AUTH_SHARED);
-	attrp->wa_valid |= DLADM_WLAN_ATTR_AUTH;
-
 	attrp->wa_strength = DLADM_WLAN_SIGNAL2STRENGTH(wlp->wl_ess_conf_sl);
 	attrp->wa_valid |= DLADM_WLAN_ATTR_STRENGTH;
 
@@ -255,6 +267,8 @@
 		attrp->wa_valid |= DLADM_WLAN_ATTR_CHANNEL;
 }
 
+#define	WLDP_BUFSIZE	(MAX_BUF_LEN - WIFI_BUF_OFFSET)
+
 dladm_status_t
 dladm_wlan_scan(dladm_handle_t handle, datalink_id_t linkid, void *arg,
     boolean_t (*func)(void *, dladm_wlan_attr_t *))
@@ -291,7 +305,7 @@
 		goto done;
 	}
 
-	if ((status = do_get_esslist(handle, linkid, wls, WLDP_BUFSIZE))
+	if ((status = dladm_wlan_get_esslist(handle, linkid, wls, WLDP_BUFSIZE))
 	    != DLADM_STATUS_OK)
 		goto done;
 
@@ -380,8 +394,8 @@
 		return (B_TRUE);
 
 	if ((fattrp->wa_valid & DLADM_WLAN_ATTR_ESSID) != 0 &&
-	    strncmp(fattrp->wa_essid.we_bytes, attrp->wa_essid.we_bytes,
-	    DLADM_WLAN_MAX_ESSID_LEN) != 0)
+	    memcmp(fattrp->wa_essid.we_bytes, attrp->wa_essid.we_bytes,
+	    attrp->wa_essid.we_length) != 0)
 		return (B_TRUE);
 
 	if ((fattrp->wa_valid & DLADM_WLAN_ATTR_SECMODE) != 0 &&
@@ -426,149 +440,24 @@
 	return (B_TRUE);
 }
 
-#define	IEEE80211_C_WPA		0x01800000
-
-static dladm_status_t
-do_connect(dladm_handle_t handle, datalink_id_t linkid, void *buf, int bufsize,
-    dladm_wlan_attr_t *attrp, boolean_t create_ibss, void *keys,
-    uint_t key_count, int timeout)
-{
-	dladm_wlan_secmode_t	secmode;
-	dladm_wlan_auth_t	authmode;
-	dladm_wlan_bsstype_t	bsstype;
-	dladm_wlan_essid_t	essid;
-	boolean_t		essid_valid = B_FALSE;
-	dladm_status_t		status;
-	dladm_wlan_channel_t	channel;
-	hrtime_t		start;
-	wl_capability_t		*caps;
-	wl_linkstatus_t		wl_status;
-
-	if ((attrp->wa_valid & DLADM_WLAN_ATTR_CHANNEL) != 0) {
-		channel = attrp->wa_channel;
-		status = do_set_channel(handle, linkid, &channel);
-		if (status != DLADM_STATUS_OK)
-			goto fail;
-	}
-
-	secmode = ((attrp->wa_valid & DLADM_WLAN_ATTR_SECMODE) != 0) ?
-	    attrp->wa_secmode : DLADM_WLAN_SECMODE_NONE;
-
-	if ((status = do_set_encryption(handle, linkid, &secmode)) !=
-	    DLADM_STATUS_OK)
-		goto fail;
-
-	authmode = ((attrp->wa_valid & DLADM_WLAN_ATTR_AUTH) != 0) ?
-	    attrp->wa_auth : DLADM_WLAN_AUTH_OPEN;
-
-	if ((status = do_set_authmode(handle, linkid, &authmode)) !=
-	    DLADM_STATUS_OK)
-		goto fail;
-
-	bsstype = ((attrp->wa_valid & DLADM_WLAN_ATTR_BSSTYPE) != 0) ?
-	    attrp->wa_bsstype : DLADM_WLAN_BSSTYPE_BSS;
-
-	if ((status = do_set_bsstype(handle, linkid, &bsstype)) !=
-	    DLADM_STATUS_OK)
-		goto fail;
-
-	if (secmode == DLADM_WLAN_SECMODE_WEP) {
-		if (keys == NULL || key_count == 0 ||
-		    key_count > MAX_NWEPKEYS) {
-			status = DLADM_STATUS_BADARG;
-			goto fail;
-		}
-		status = do_set_key(handle, linkid, keys, key_count);
-		if (status != DLADM_STATUS_OK)
-			goto fail;
-	} else if (secmode == DLADM_WLAN_SECMODE_WPA) {
-		if (keys == NULL || key_count == 0 ||
-		    key_count > MAX_NWEPKEYS) {
-			status = DLADM_STATUS_BADARG;
-			goto fail;
-		}
-		status = do_get_capability(handle, linkid, buf, bufsize);
-		if (status != DLADM_STATUS_OK)
-			goto fail;
-		caps = (wl_capability_t *)buf;
-		if ((caps->caps & IEEE80211_C_WPA) == 0)
-			return (DLADM_STATUS_NOTSUP);
-	}
-
-	if (create_ibss) {
-		status = do_set_channel(handle, linkid, &channel);
-		if (status != DLADM_STATUS_OK)
-			goto fail;
-
-		status = do_set_createibss(handle, linkid, &create_ibss);
-		if (status != DLADM_STATUS_OK)
-			goto fail;
-
-		if ((attrp->wa_valid & DLADM_WLAN_ATTR_ESSID) == 0) {
-			generate_essid(&essid);
-			essid_valid = B_TRUE;
-		}
-	}
-
-	if ((attrp->wa_valid & DLADM_WLAN_ATTR_ESSID) != 0) {
-		essid = attrp->wa_essid;
-		essid_valid = B_TRUE;
-	}
-
-	if (!essid_valid) {
-		status = DLADM_STATUS_FAILED;
-		goto fail;
-	}
-
-	if ((status = do_set_essid(handle, linkid, &essid)) != DLADM_STATUS_OK)
-		goto fail;
-
-	/*
-	 * Because wpa daemon needs getting essid from driver,
-	 * we need call do_set_essid() first, then call wpa_instance_create().
-	 */
-	if (secmode == DLADM_WLAN_SECMODE_WPA && keys != NULL)
-		(void) wpa_instance_create(handle, linkid, keys);
-
-	start = gethrtime();
-	for (;;) {
-		status = do_get_linkstatus(handle, linkid, &wl_status,
-		    sizeof (wl_status));
-		if (status != DLADM_STATUS_OK)
-			goto fail;
-
-		if (wl_status == WL_CONNECTED)
-			break;
-
-		(void) poll(NULL, 0, DLADM_WLAN_CONNECT_POLLRATE);
-		if ((timeout >= 0) && (gethrtime() - start) /
-		    NANOSEC >= timeout) {
-			status = DLADM_STATUS_TIMEDOUT;
-			goto fail;
-		}
-	}
-	status = DLADM_STATUS_OK;
-fail:
-	return (status);
-}
-
 dladm_status_t
 dladm_wlan_connect(dladm_handle_t handle, datalink_id_t linkid,
-    dladm_wlan_attr_t *attrp, int timeout, void *keys, uint_t key_count,
-    uint_t flags)
+    dladm_wlan_attr_t *attrp, int timeout, void *keys,
+    uint_t key_count, uint_t flags, char *identity)
 {
-	int			i;
-	char 			buf[WLDP_BUFSIZE];
-	connect_state_t		state = {0, NULL, NULL};
-	attr_node_t		*nodep = NULL;
-	boolean_t		create_ibss, set_authmode;
-	dladm_wlan_attr_t	**wl_list = NULL;
+	char			ifname[MAXLINKNAMELEN];
+	boolean_t		create_ibss;
 	dladm_status_t		status;
 	wl_linkstatus_t		wl_status;
+	hrtime_t		start;
 
 	if ((status = dladm_wlan_validate(handle, linkid)) != DLADM_STATUS_OK)
 		return (status);
 
+	if ((status = dladm_datalink_id2info(handle, linkid, NULL, NULL, NULL,
+	    ifname, sizeof (ifname))) != DLADM_STATUS_OK)
+		goto done;
+
 	if ((status = do_get_linkstatus(handle, linkid, &wl_status,
 	    sizeof (wl_status))) != DLADM_STATUS_OK)
 		goto done;
@@ -578,80 +467,65 @@
 		goto done;
 	}
 
-	set_authmode = ((attrp != NULL) &&
-	    (attrp->wa_valid & DLADM_WLAN_ATTR_MODE) != 0);
+	if (wpa_instance_create(ifname))
+		goto done;
+
+	if (wpa_network_config(ifname, attrp, keys, &create_ibss, identity)) {
+		status = DLADM_STATUS_BADVAL;
+		goto done;
+	}
+
+	/*
+	 * DLADM_WLAN_CONNECT_CREATEIBSS:
+	 * If this flag is set and the bsstype attribute attr->wa_bsstype is
+	 * set to DLADM_WLAN_BSSTYPE_IBSS:
+	 * If the essid attribute attr->wa_essid is specified and there exists
+	 * no WLAN on the discovered WLAN with this particular essid, an adhoc
+	 * WLAN with essid equal to attr->wa_essid will be created.
+	 * If the essid attribute is not specified, an adhoc WLAN with a random
+	 * essid will be created, irrespective of which WLANs are available.
+	 */
+
+	/* we will manage this inside wpa_network config
 	create_ibss = ((flags & DLADM_WLAN_CONNECT_CREATEIBSS) != 0 &&
-	    attrp != NULL &&
-	    (attrp->wa_valid & DLADM_WLAN_ATTR_BSSTYPE) != 0 &&
+	    attrp != NULL && (attrp->wa_valid & DLADM_WLAN_ATTR_BSSTYPE) != 0 &&
 	    attrp->wa_bsstype == DLADM_WLAN_BSSTYPE_IBSS);
 
-	if ((flags & DLADM_WLAN_CONNECT_NOSCAN) != 0 ||
-	    (create_ibss && attrp != NULL &&
+	if ((create_ibss && attrp != NULL &&
 	    (attrp->wa_valid & DLADM_WLAN_ATTR_ESSID) == 0)) {
 		status = do_connect(handle, linkid, buf, sizeof (buf), attrp,
 		    create_ibss, keys, key_count, timeout);
 		goto done;
-	}
-
-	state.cs_attr = attrp;
-	state.cs_list = NULL;
-	state.cs_count = 0;
-
-	status = dladm_wlan_scan(handle, linkid, &state, connect_cb);
-	if (status != DLADM_STATUS_OK)
-		goto done;
 
 	if (state.cs_count == 0) {
 		if (!create_ibss) {
 			status = DLADM_STATUS_NOTFOUND;
 			goto done;
 		}
-		status = do_connect(handle, linkid, buf, sizeof (buf),
-		    attrp, create_ibss, keys, key_count, timeout);
-		goto done;
-	}
+	} */
 
-	wl_list = malloc(state.cs_count * sizeof (dladm_wlan_attr_t *));
-	if (wl_list == NULL) {
-		status = DLADM_STATUS_NOMEM;
-		goto done;
-	}
+	start = gethrtime();
+	for (;;) {
+		status = do_get_linkstatus(handle, linkid, &wl_status,
+		    sizeof (wl_status));
+		if (status != DLADM_STATUS_OK)
+			goto done;
 
-	nodep = state.cs_list;
-	for (i = 0; i < state.cs_count; i++) {
-		wl_list[i] = &nodep->an_attr;
-		nodep = nodep->an_next;
-	}
-	qsort(wl_list, state.cs_count, sizeof (dladm_wlan_attr_t *),
-	    attr_compare);
-
-	for (i = 0; i < state.cs_count; i++) {
-		dladm_wlan_attr_t	*ap = wl_list[i];
-
-		status = do_connect(handle, linkid, buf, sizeof (buf),
-		    ap, create_ibss, keys, key_count, timeout);
-		if (status == DLADM_STATUS_OK)
+		if (wl_status == WL_CONNECTED)
 			break;
 
-		if (!set_authmode) {
-			ap->wa_auth = DLADM_WLAN_AUTH_SHARED;
-			ap->wa_valid |= DLADM_WLAN_ATTR_AUTH;
-			status = do_connect(handle, linkid, buf, sizeof (buf),
-			    ap, create_ibss, keys, key_count, timeout);
-			if (status == DLADM_STATUS_OK)
-				break;
+		(void) poll(NULL, 0, DLADM_WLAN_CONNECT_POLLRATE);
+		if ((timeout >= 0) && (gethrtime() - start) /
+		    NANOSEC >= timeout) {
+			status = DLADM_STATUS_TIMEDOUT;
+			goto done;
 		}
 	}
+
 done:
 	if ((status != DLADM_STATUS_OK) && (status != DLADM_STATUS_ISCONN))
-		(void) do_disconnect(handle, linkid, buf, sizeof (buf));
+		(void) do_disconnect(handle, linkid, NULL, NULL);
 
-	while (state.cs_list != NULL) {
-		nodep = state.cs_list;
-		state.cs_list = nodep->an_next;
-		free(nodep);
-	}
-	free(wl_list);
 	return (status);
 }
 
@@ -699,11 +573,12 @@
 	wl_rssi_t		signal;
 	wl_bss_type_t		bsstype;
 	wl_authmode_t		authmode;
+	/* used only in dladm show-wifi */
 	wl_encryption_t		encryption;
 	wl_rates_t		*ratesp = NULL;
 	dladm_wlan_attr_t	*wl_attrp;
 	dladm_status_t		status;
-	char			buf[WLDP_BUFSIZE];
+	wl_bssid_t		wl_bssid;
 	wl_essid_t		wls;
 	wl_phy_conf_t		wl_phy_conf;
 	wl_linkstatus_t		wl_status;
@@ -727,21 +602,20 @@
 	else
 		attrp->la_status = DLADM_WLAN_LINK_CONNECTED;
 
-	if ((status = do_get_essid(handle, linkid, &wls, sizeof (wls)))
+	/* essid */
+	if ((status = dladm_wlan_get_essid(handle, linkid, &wls, sizeof (wls)))
 	    != DLADM_STATUS_OK)
 		goto done;
-
-	(void) strlcpy(wl_attrp->wa_essid.we_bytes, wls.wl_essid_essid,
-	    DLADM_WLAN_MAX_ESSID_LEN);
-
+	wl_attrp->wa_essid.we_length = wls.wl_essid_length;
+	(void) memcpy(wl_attrp->wa_essid.we_bytes, wls.wl_essid_essid,
+	    wls.wl_essid_length);
 	wl_attrp->wa_valid |= DLADM_WLAN_ATTR_ESSID;
 
-	if ((status = do_get_bssid(handle, linkid, buf, sizeof (buf)))
+	/* bssid */
+	if ((status = dladm_wlan_get_bssid(handle, linkid, wl_bssid, sizeof (wl_bssid)))
 	    != DLADM_STATUS_OK)
 		goto done;
-
-	(void) memcpy(wl_attrp->wa_bssid.wb_bytes, buf, DLADM_WLAN_BSSID_LEN);
-
+	(void) memcpy(wl_attrp->wa_bssid.wb_bytes, wl_bssid, DLADM_WLAN_BSSID_LEN);
 	wl_attrp->wa_valid |= DLADM_WLAN_ATTR_BSSID;
 
 	if (attrp->la_status == DLADM_WLAN_LINK_DISCONNECTED) {
@@ -750,12 +624,18 @@
 		goto done;
 	}
 
+	/* returned values used only in dladm show-wifi */
 	if ((status = do_get_encryption(handle, linkid, &encryption,
 	    sizeof (encryption))) != DLADM_STATUS_OK)
 		goto done;
 
 	wl_attrp->wa_valid |= DLADM_WLAN_ATTR_SECMODE;
 
+	/* !!!! FIX ME!!!! */
+	/*
+	 *  this should be alligned with protocol/scan results,
+	 * not types of keys used
+	 */
 	switch (encryption) {
 	case WL_NOENCRYPTION:
 		wl_attrp->wa_secmode = DLADM_WLAN_SECMODE_NONE;
@@ -764,7 +644,7 @@
 		wl_attrp->wa_secmode = DLADM_WLAN_SECMODE_WEP;
 		break;
 	case WL_ENC_WPA:
-		wl_attrp->wa_secmode = DLADM_WLAN_SECMODE_WPA;
+		wl_attrp->wa_secmode = DLADM_WLAN_SECMODE_PSK;
 		break;
 	default:
 		wl_attrp->wa_valid &= ~DLADM_WLAN_ATTR_SECMODE;
@@ -830,9 +710,6 @@
 	case WL_BSS_IBSS:
 		wl_attrp->wa_bsstype = DLADM_WLAN_BSSTYPE_IBSS;
 		break;
-	case WL_BSS_ANY:
-		wl_attrp->wa_bsstype = DLADM_WLAN_BSSTYPE_ANY;
-		break;
 	default:
 		wl_attrp->wa_valid &= ~DLADM_WLAN_ATTR_BSSTYPE;
 		break;
@@ -901,10 +778,12 @@
 	return (B_FALSE);
 }
 
+/* data to string */
+
 const char *
 dladm_wlan_essid2str(dladm_wlan_essid_t *essid, char *buf)
 {
-	(void) snprintf(buf, DLADM_STRSIZE, "%s", essid->we_bytes);
+	(void) snprintf(buf, essid->we_length+1, "%s", essid->we_bytes);
 	return (buf);
 }
 
@@ -927,6 +806,10 @@
 	return (buf);
 }
 
+/*
+ * SECMODE SHOULD NEVER BE PRINTED, in known-wlan.conf and secobj.conf we'll use
+ * secobj_class values, and for scan results wpa_s values
+ */
 const char *
 dladm_wlan_secmode2str(dladm_wlan_secmode_t *secmode, char *buf)
 {
@@ -977,13 +860,17 @@
 	    VALCNT(linkstatus_vals), buf));
 }
 
+/* string to data */
+
 dladm_status_t
 dladm_wlan_str2essid(const char *str, dladm_wlan_essid_t *essid)
 {
-	if (str[0] == '\0' || strlen(str) > DLADM_WLAN_MAX_ESSID_LEN - 1)
+	if (str[0] == '\0' || strnlen(str, DLADM_WLAN_MAX_ESSID_LEN + 2) ==
+	    DLADM_WLAN_MAX_ESSID_LEN + 2)
 		return (DLADM_STATUS_BADARG);
 
-	(void) strlcpy(essid->we_bytes, str, DLADM_WLAN_MAX_ESSID_LEN);
+	essid->we_length=strnlen(str, DLADM_WLAN_MAX_ESSID_LEN + 1);
+	(void) memcpy(essid->we_bytes, str, essid->we_length);
 	return (DLADM_STATUS_OK);
 }
 
@@ -1088,6 +975,8 @@
 	return (DLADM_STATUS_OK);
 }
 
+/* legacy ioctl for WL_SCAN and WL_DISASSOCIATE */
+
 dladm_status_t
 i_dladm_wlan_legacy_ioctl(dladm_handle_t handle, datalink_id_t linkid,
     wldp_t *gbuf, uint_t id, size_t len, uint_t cmd, size_t cmdlen)
@@ -1175,30 +1064,38 @@
 do_disconnect(dladm_handle_t handle, datalink_id_t linkid, void *buf,
     int buflen)
 {
-	if (do_get_wpamode(handle, linkid, buf, buflen) == 0 &&
-	    ((wl_wpa_t *)(buf))->wpa_flag > 0)
-		(void) wpa_instance_delete(handle, linkid);
+	char ifname[MAXLINKNAMELEN];
+	if ((dladm_datalink_id2info(handle, linkid, NULL, NULL, NULL, ifname,
+	    sizeof (ifname))) != DLADM_STATUS_OK)
+	    		return DLADM_STATUS_FAILED;
+		(void) wpa_instance_delete(ifname);
 
 	return (do_cmd_ioctl(handle, linkid, buf, buflen, WL_DISASSOCIATE));
 }
 
-static dladm_status_t
-do_get_esslist(dladm_handle_t handle, datalink_id_t linkid, void *buf,
+/*
+ * 'net80211' ioctls wrappers
+ * wlan properties are not currenlty merged into the Brussels framework.
+ * we should implement a common interface like this:http://pastebin.com/B05BkQJ2
+ */
+
+dladm_status_t
+dladm_wlan_get_esslist(dladm_handle_t handle, datalink_id_t linkid, void *buf,
     int buflen)
 {
 	return (i_dladm_wlan_param(handle, linkid, buf, MAC_PROP_WL_ESS_LIST,
 	    buflen, B_FALSE));
 }
 
-static dladm_status_t
-do_get_bssid(dladm_handle_t handle, datalink_id_t linkid, void *buf, int buflen)
+dladm_status_t
+dladm_wlan_get_bssid(dladm_handle_t handle, datalink_id_t linkid, void *buf, int buflen)
 {
 	return (i_dladm_wlan_param(handle, linkid, buf, MAC_PROP_WL_BSSID,
 	    buflen, B_FALSE));
 }
 
-static dladm_status_t
-do_get_essid(dladm_handle_t handle, datalink_id_t linkid, void *buf, int buflen)
+dladm_status_t
+dladm_wlan_get_essid(dladm_handle_t handle, datalink_id_t linkid, void *buf, int buflen)
 {
 	return (i_dladm_wlan_param(handle, linkid, buf, MAC_PROP_WL_ESSID,
 	    buflen, B_FALSE));
@@ -1258,8 +1155,8 @@
 	    buflen, B_FALSE));
 }
 
-static dladm_status_t
-do_set_bsstype(dladm_handle_t handle, datalink_id_t linkid,
+dladm_status_t
+dladm_wlan_set_bsstype(dladm_handle_t handle, datalink_id_t linkid,
     dladm_wlan_bsstype_t *bsstype)
 {
 	wl_bss_type_t	ibsstype;
@@ -1272,20 +1169,22 @@
 		ibsstype = WL_BSS_IBSS;
 		break;
 	default:
-		ibsstype = WL_BSS_ANY;
+		ibsstype = WL_BSS_BSS;
 		break;
 	}
 	return (i_dladm_wlan_param(handle, linkid, &ibsstype,
 	    MAC_PROP_WL_BSSTYPE, sizeof (ibsstype), B_TRUE));
 }
 
-static dladm_status_t
-do_set_authmode(dladm_handle_t handle, datalink_id_t linkid,
+dladm_status_t
+dladm_wlan_set_authmode(dladm_handle_t handle, datalink_id_t linkid,
     dladm_wlan_auth_t *auth)
 {
 	wl_authmode_t	auth_mode;
 
 	switch (*auth) {
+	case DLADM_WLAN_AUTH_NONE:
+		return (DLADM_STATUS_OK);
 	case DLADM_WLAN_AUTH_OPEN:
 		auth_mode = WL_OPENSYSTEM;
 		break;
@@ -1299,8 +1198,9 @@
 	    MAC_PROP_WL_AUTH_MODE, sizeof (auth_mode), B_TRUE));
 }
 
-static dladm_status_t
-do_set_encryption(dladm_handle_t handle, datalink_id_t linkid,
+/* should be renamed to a more appropriate name since it is only for WEP !!*/
+dladm_status_t
+dladm_wlan_set_encryption(dladm_handle_t handle, datalink_id_t linkid,
     dladm_wlan_secmode_t *secmode)
 {
 	wl_encryption_t	encryption;
@@ -1312,7 +1212,7 @@
 	case DLADM_WLAN_SECMODE_WEP:
 		encryption = WL_ENC_WEP;
 		break;
-	case DLADM_WLAN_SECMODE_WPA:
+	case DLADM_WLAN_SECMODE_PSK:
 		return (0);
 	default:
 		return (DLADM_STATUS_NOTSUP);
@@ -1355,18 +1255,18 @@
 	    MAC_PROP_WL_KEY_TAB, sizeof (wepkey_tab), B_TRUE));
 }
 
-static dladm_status_t
-do_set_essid(dladm_handle_t handle, datalink_id_t linkid,
-    dladm_wlan_essid_t *essid)
+dladm_status_t
+dladm_wlan_set_essid(dladm_handle_t handle, datalink_id_t linkid,
+    const uint8_t *essid, size_t essid_len)
 {
 	wl_essid_t	iessid;
 
-	(void) memset(&iessid, 0, sizeof (essid));
+	(void) memset(&iessid, 0, essid_len);
 
-	if (essid != NULL && essid->we_bytes[0] != '\0') {
-		iessid.wl_essid_length = strlen(essid->we_bytes);
-		(void) strlcpy(iessid.wl_essid_essid, essid->we_bytes,
-		    sizeof (iessid.wl_essid_essid));
+	if (essid != NULL && essid_len != 0) {
+		iessid.wl_essid_length = essid_len;
+		(void) memcpy(iessid.wl_essid_essid, essid,
+		    iessid.wl_essid_length);
 	} else {
 		return (DLADM_STATUS_BADARG);
 	}
@@ -1374,8 +1274,23 @@
 	    sizeof (iessid), B_TRUE));
 }
 
-static dladm_status_t
-do_set_channel(dladm_handle_t handle, datalink_id_t linkid,
+dladm_status_t
+do_set_bssid(dladm_handle_t handle, datalink_id_t linkid,
+    dladm_wlan_bssid_t *bssid)
+{
+	wl_bssid_t	ibssid;
+
+	if (bssid != NULL && bssid->wb_bytes != 0) {
+		(void) memcpy(ibssid, bssid->wb_bytes, DLADM_WLAN_BSSID_LEN);
+	} else {
+		return (DLADM_STATUS_BADARG);
+	}
+	return (i_dladm_wlan_param(handle, linkid, &ibssid, MAC_PROP_WL_BSSID,
+	    sizeof (ibssid), B_TRUE));
+}
+
+dladm_status_t
+dladm_wlan_set_channel(dladm_handle_t handle, datalink_id_t linkid,
     dladm_wlan_channel_t *channel)
 {
 	wl_phy_conf_t phy_conf;
@@ -1390,7 +1305,7 @@
 	    MAC_PROP_WL_PHY_CONFIG, sizeof (phy_conf), B_TRUE));
 }
 
-static dladm_status_t
+dladm_status_t
 do_set_createibss(dladm_handle_t handle, datalink_id_t linkid,
     boolean_t *create_ibss)
 {
@@ -1403,12 +1318,14 @@
 static void
 generate_essid(dladm_wlan_essid_t *essid)
 {
+	char ssid_temp[DLADM_WLAN_MAX_ESSID_LEN];
 	srandom(gethrtime());
-	(void) snprintf(essid->we_bytes, DLADM_WLAN_MAX_ESSID_LEN, "%d",
-	    random());
+	snprintf(ssid_temp, DLADM_WLAN_MAX_ESSID_LEN, "Illumos-%s", random());
+	(void) memcpy(essid->we_bytes,ssid_temp,16);
+	essid->we_length=16;
 }
 
-static dladm_status_t
+dladm_status_t
 do_get_capability(dladm_handle_t handle, datalink_id_t linkid, void *buf,
     int buflen)
 {
@@ -1424,44 +1341,11 @@
 	    B_FALSE));
 }
 
-dladm_status_t
-dladm_wlan_wpa_get_sr(dladm_handle_t handle, datalink_id_t linkid,
-    dladm_wlan_ess_t *sr, uint_t escnt, uint_t *estot)
-{
-	int		i, n;
-	wl_wpa_ess_t	*es;
-	dladm_status_t	status;
-
-	es = malloc(WLDP_BUFSIZE);
-	if (es == NULL)
-		return (DLADM_STATUS_NOMEM);
-
-	status = i_dladm_wlan_param(handle, linkid, es, MAC_PROP_WL_SCANRESULTS,
-	    WLDP_BUFSIZE, B_FALSE);
-
-	if (status == DLADM_STATUS_OK) {
-		n = (es->count > escnt) ? escnt : es->count;
-		for (i = 0; i < n; i ++) {
-			(void) memcpy(sr[i].we_bssid.wb_bytes, es->ess[i].bssid,
-			    DLADM_WLAN_BSSID_LEN);
-			sr[i].we_ssid_len = es->ess[i].ssid_len;
-			(void) memcpy(sr[i].we_ssid.we_bytes, es->ess[i].ssid,
-			    es->ess[i].ssid_len);
-			sr[i].we_wpa_ie_len = es->ess[i].wpa_ie_len;
-			(void) memcpy(sr[i].we_wpa_ie, es->ess[i].wpa_ie,
-			    es->ess[i].wpa_ie_len);
-			sr[i].we_freq = es->ess[i].freq;
-		}
-		*estot = n;
-	}
-
-	free(es);
-	return (status);
-}
+/* WPA support routines */
 
 dladm_status_t
 dladm_wlan_wpa_set_ie(dladm_handle_t handle, datalink_id_t linkid,
-    uint8_t *wpa_ie, uint_t wpa_ie_len)
+    const uint8_t *wpa_ie, size_t wpa_ie_len)
 {
 	wl_wpa_ie_t *ie;
 	uint_t len;
@@ -1560,8 +1444,7 @@
 
 dladm_status_t
 dladm_wlan_wpa_set_mlme(dladm_handle_t handle, datalink_id_t linkid,
-    dladm_wlan_mlme_op_t op, dladm_wlan_reason_t reason,
-    dladm_wlan_bssid_t *bssid)
+    dladm_wlan_mlme_op_t op, dladm_wlan_reason_t reason, const uint8_t *bssid)
 {
 	wl_mlme_t mlme;
 
